org.springframework.core.type.classreading

## Class AnnotationMetadataReadingVisitor

- java.lang.Object
- - org.springframework.asm.ClassVisitor
  - - org.springframework.core.type.classreading.AnnotationMetadataReadingVisitor

- All Implemented Interfaces:
    AnnotatedTypeMetadata, AnnotationMetadata, ClassMetadata

  Deprecated.
  As of Spring Framework 5.2, this class has been replaced by `SimpleAnnotationMetadataReadingVisitor` for internal use within the framework, but there is no public replacement for `AnnotationMetadataReadingVisitor`.

      @Deprecated
      public class AnnotationMetadataReadingVisitor
      extends ClassVisitor
      implements AnnotationMetadata

  ASM class visitor which looks for the class name and implemented types as well as for the annotations defined on the class, exposing them through the `AnnotationMetadata` interface.
  Since:
    2.5
  Author:
    Juergen Hoeller, Mark Fisher, Costin Leau, Phillip Webb, Sam Brannen

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Set<String>` | `annotationSet` Deprecated.
    `protected LinkedMultiValueMap<String,AnnotationAttributes>` | `attributesMap` Deprecated. Declared as a `LinkedMultiValueMap` instead of a `MultiValueMap` to ensure that the hierarchical ordering of the entries is preserved.
    `protected ClassLoader` | `classLoader` Deprecated.
    `protected Map<String,Set<String>>` | `metaAnnotationMap` Deprecated.
    `protected Set<MethodMetadata>` | `methodMetadataSet` Deprecated.

    - ### Fields inherited from class org.springframework.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AnnotationMetadataReadingVisitor(ClassLoader classLoader)` Deprecated.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `MultiValueMap<String,Object>` | `getAllAnnotationAttributes(String annotationName, boolean classValuesAsString)` Deprecated. Retrieve all attributes of all annotations of the given type, if any (i.e.
    `Set<MethodMetadata>` | `getAnnotatedMethods(String annotationName)` Deprecated. Retrieve the method metadata for all methods that are annotated (or meta-annotated) with the given annotation type.
    `AnnotationAttributes` | `getAnnotationAttributes(String annotationName, boolean classValuesAsString)` Deprecated. Retrieve the attributes of the annotation of the given type, if any (i.e.
    `MergedAnnotations` | `getAnnotations()` Deprecated. Return annotation details based on the direct annotations of the underlying element.
    `Set<String>` | `getAnnotationTypes()` Deprecated. Get the fully qualified class names of all annotation types that are present on the underlying class.
    `String` | `getClassName()` Deprecated. Return the name of the underlying class.
    `String` | `getEnclosingClassName()` Deprecated. Return the name of the enclosing class of the underlying class, or `null` if the underlying class is a top-level class.
    `String[]` | `getInterfaceNames()` Deprecated. Return the names of all interfaces that the underlying class implements, or an empty array if there are none.
    `String[]` | `getMemberClassNames()` Deprecated. Return the names of all classes declared as members of the class represented by this ClassMetadata object.
    `Set<String>` | `getMetaAnnotationTypes(String annotationName)` Deprecated. Get the fully qualified class names of all meta-annotation types that are present on the given annotation type on the underlying class.
    `String` | `getSuperClassName()` Deprecated. Return the name of the superclass of the underlying class, or `null` if there is no superclass defined.
    `boolean` | `hasAnnotatedMethods(String annotationName)` Deprecated. Determine whether the underlying class has any methods that are annotated (or meta-annotated) with the given annotation type.
    `boolean` | `hasAnnotation(String annotationName)` Deprecated. Determine whether an annotation of the given type is present on the underlying class.
    `boolean` | `hasEnclosingClass()` Deprecated. Return whether the underlying class is declared within an enclosing class (i.e.
    `boolean` | `hasMetaAnnotation(String metaAnnotationType)` Deprecated. Determine whether the underlying class has an annotation that is itself annotated with the meta-annotation of the given type.
    `boolean` | `isAbstract()` Deprecated. Return whether the underlying class is marked as abstract.
    `boolean` | `isAnnotated(String annotationName)` Deprecated. Determine whether the underlying element has an annotation or meta-annotation of the given type defined.
    `boolean` | `isAnnotation()` Deprecated. Return whether the underlying class represents an annotation.
    `boolean` | `isFinal()` Deprecated. Return whether the underlying class is marked as 'final'.
    `boolean` | `isIndependent()` Deprecated. Determine whether the underlying class is independent, i.e.
    `boolean` | `isInterface()` Deprecated. Return whether the underlying class represents an interface.
    `void` | `visit(int version, int access, String name, String signature, String supername, String[] interfaces)` Deprecated. Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Deprecated. Visits an annotation of the class.
    `void` | `visitAttribute(Attribute attr)` Deprecated. Visits a non standard attribute of the class.
    `void` | `visitEnd()` Deprecated. Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Deprecated. Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Deprecated. Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Deprecated. Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Deprecated. Visits the enclosing class of the class.
    `void` | `visitSource(String source, String debug)` Deprecated. Visits the source of the class.

    - ### Methods inherited from class org.springframework.asm.ClassVisitor

      `getDelegate, visitModule, visitNestHost, visitNestMember, visitPermittedSubclass, visitRecordComponent, visitTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.core.type.AnnotationMetadata

      `introspect`

    - ### Methods inherited from interface org.springframework.core.type.ClassMetadata

      `getClassName, getEnclosingClassName, getInterfaceNames, getMemberClassNames, getSuperClassName, hasEnclosingClass, hasSuperClass, isAbstract, isAnnotation, isConcrete, isFinal, isIndependent, isInterface`

    - ### Methods inherited from interface org.springframework.core.type.AnnotatedTypeMetadata

      `getAllAnnotationAttributes, getAnnotationAttributes`

- - ### Field Detail

    - #### classLoader

          @Nullable
          protected final ClassLoader classLoader

      Deprecated.

    - #### annotationSet

          protected final Set<String> annotationSet

      Deprecated.

    - #### metaAnnotationMap

          protected final Map<String,Set<String>> metaAnnotationMap

      Deprecated.

    - #### attributesMap

          protected final LinkedMultiValueMap<String,AnnotationAttributes> attributesMap

      Deprecated.
      Declared as a `LinkedMultiValueMap` instead of a `MultiValueMap` to ensure that the hierarchical ordering of the entries is preserved.
      See Also:
        `AnnotationReadingVisitorUtils.getMergedAnnotationAttributes(org.springframework.util.LinkedMultiValueMap<java.lang.String, org.springframework.core.annotation.AnnotationAttributes>, java.util.Map<java.lang.String, java.util.Set<java.lang.String>>, java.lang.String)`

    - #### methodMetadataSet

          protected final Set<MethodMetadata> methodMetadataSet

      Deprecated.

  - ### Constructor Detail

    - #### AnnotationMetadataReadingVisitor

          public AnnotationMetadataReadingVisitor(@Nullable
                                                  ClassLoader classLoader)

      Deprecated.

  - ### Method Detail

    - #### getAnnotations

          public MergedAnnotations getAnnotations()

      Deprecated.
      Description copied from interface: `AnnotatedTypeMetadata`
      Return annotation details based on the direct annotations of the underlying element.
      Specified by:
        `getAnnotations` in interface `AnnotatedTypeMetadata`
      Returns:
        merged annotations based on the direct annotations

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                           String name,
                                           String desc,
                                           String signature,
                                           String[] exceptions)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or null) each time it is called, i.e., it should not return a previously returned visitor.
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be null if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `Type.getInternalName()`). May be null.
      Returns:
        an object to visit the byte code of the method, or null if this class visitor is not interested in visiting the code of this method.

    - #### visitAnnotation

          @Nullable
          public AnnotationVisitor visitAnnotation(String desc,
                                                             boolean visible)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - true if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or null if this visitor is not interested in visiting this annotation.

    - #### getAnnotationTypes

          public Set<String> getAnnotationTypes()

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Get the fully qualified class names of all annotation types that are present on the underlying class.
      Specified by:
        `getAnnotationTypes` in interface `AnnotationMetadata`
      Returns:
        the annotation type names

    - #### getMetaAnnotationTypes

          public Set<String> getMetaAnnotationTypes(String annotationName)

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Get the fully qualified class names of all meta-annotation types that are present on the given annotation type on the underlying class.
      Specified by:
        `getMetaAnnotationTypes` in interface `AnnotationMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the meta-annotation type to look for
      Returns:
        the meta-annotation type names, or an empty set if none found

    - #### hasMetaAnnotation

          public boolean hasMetaAnnotation(String metaAnnotationType)

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Determine whether the underlying class has an annotation that is itself annotated with the meta-annotation of the given type.
      Specified by:
        `hasMetaAnnotation` in interface `AnnotationMetadata`
      Parameters:
        `metaAnnotationType` - the fully qualified class name of the meta-annotation type to look for
      Returns:
        `true` if a matching meta-annotation is present

    - #### isAnnotated

          public boolean isAnnotated(String annotationName)

      Deprecated.
      Description copied from interface: `AnnotatedTypeMetadata`
      Determine whether the underlying element has an annotation or meta-annotation of the given type defined.

      If this method returns `true`, then `AnnotatedTypeMetadata.getAnnotationAttributes(java.lang.String)` will return a non-null Map.

      Specified by:
        `isAnnotated` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for
      Returns:
        whether a matching annotation is defined

    - #### hasAnnotation

          public boolean hasAnnotation(String annotationName)

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Determine whether an annotation of the given type is present on the underlying class.
      Specified by:
        `hasAnnotation` in interface `AnnotationMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for
      Returns:
        `true` if a matching annotation is present

    - #### getAnnotationAttributes

          @Nullable
          public AnnotationAttributes getAnnotationAttributes(String annotationName,
                                                                        boolean classValuesAsString)

      Deprecated.
      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve the attributes of the annotation of the given type, if any (i.e. if defined on the underlying element, as direct annotation or meta-annotation), also taking attribute overrides on composed annotations into account.
      Specified by:
        `getAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for
        `classValuesAsString` - whether to convert class references to String class names for exposure as values in the returned Map, instead of Class references which might potentially have to be loaded first
      Returns:
        a Map of attributes, with the attribute name as key (e.g. "value") and the defined attribute value as Map value. This return value will be `null` if no matching annotation is defined.

    - #### getAllAnnotationAttributes

          @Nullable
          public MultiValueMap<String,Object> getAllAnnotationAttributes(String annotationName,
                                                                                   boolean classValuesAsString)

      Deprecated.
      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve all attributes of all annotations of the given type, if any (i.e. if defined on the underlying element, as direct annotation or meta-annotation). Note that this variant does not take attribute overrides into account.
      Specified by:
        `getAllAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for
        `classValuesAsString` - whether to convert class references to String
      Returns:
        a MultiMap of attributes, with the attribute name as key (e.g. "value") and a list of the defined attribute values as Map value. This return value will be `null` if no matching annotation is defined.
      See Also:
        `AnnotatedTypeMetadata.getAllAnnotationAttributes(String)`

    - #### hasAnnotatedMethods

          public boolean hasAnnotatedMethods(String annotationName)

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Determine whether the underlying class has any methods that are annotated (or meta-annotated) with the given annotation type.
      Specified by:
        `hasAnnotatedMethods` in interface `AnnotationMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for

    - #### getAnnotatedMethods

          public Set<MethodMetadata> getAnnotatedMethods(String annotationName)

      Deprecated.
      Description copied from interface: `AnnotationMetadata`
      Retrieve the method metadata for all methods that are annotated (or meta-annotated) with the given annotation type.

      For any returned method, `AnnotatedTypeMetadata.isAnnotated(java.lang.String)` will return `true` for the given annotation type.

      Specified by:
        `getAnnotatedMethods` in interface `AnnotationMetadata`
      Parameters:
        `annotationName` - the fully qualified class name of the annotation type to look for
      Returns:
        a set of `MethodMetadata` for methods that have a matching annotation. The return value will be an empty set if no methods match the annotation type.

    - #### visit

          public void visit(int version,
                            int access,
                            String name,
                            String signature,
                            @Nullable
                            String supername,
                            String[] interfaces)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version. The minor version is stored in the 16 most significant bits, and the major version in the 16 least significant bits.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated `Opcodes.ACC_DEPRECATED` or a record `Opcodes.ACC_RECORD`.
        `name` - the internal name of the class (see `Type.getInternalName()`).
        `signature` - the signature of this class. May be null if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `supername` - the internal of name of the super class (see `Type.getInternalName()`). For interfaces, the super class is `Object`. May be null, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `Type.getInternalName()`). May be null.

    - #### visitOuterClass

          public void visitOuterClass(String owner,
                                      String name,
                                      String desc)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if this class is a local or anonymous class. See the JVMS 4.7.7 section for more details.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class (see `Type.getInternalName()`).
        `name` - the name of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (e.g. if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).
        `desc` - the descriptor of the method that contains the class, or null if the class is not enclosed in a method or constructor of its enclosing class (e.g. if it is enclosed in an instance initializer, static initializer, instance variable initializer, or class variable initializer).

    - #### visitInnerClass

          public void visitInnerClass(String name,
                                      @Nullable
                                      String outerName,
                                      String innerName,
                                      int access)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited. More precisely, every class or interface C which is referenced by this class and which is not a package member must be visited with this method. This class must reference its nested class or interface members, and its enclosing class, if any. See the JVMS 4.7.6 section for more details.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of C (see `Type.getInternalName()`).
        `outerName` - the internal name of the class or interface C is a member of (see `Type.getInternalName()`). Must be null if C is not the member of a class or interface (e.g. for local or anonymous classes).
        `innerName` - the (simple) name of C. Must be null for anonymous inner classes.
        `access` - the access flags of C originally declared in the source code from which this class was compiled.

    - #### visitSource

          public void visitSource(String source,
                                  String debug)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `source` - the name of the source file from which the class was compiled. May be null.
        `debug` - additional debug information to compute the correspondence between source and compiled elements of the class. May be null.

    - #### visitAttribute

          public void visitAttribute(Attribute attr)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits a non standard attribute of the class.
      Overrides:
        `visitAttribute` in class `ClassVisitor`
      Parameters:
        `attr` - an attribute.

    - #### visitField

          public FieldVisitor visitField(int access,
                                         String name,
                                         String desc,
                                         String signature,
                                         Object value)

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be null if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be null if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitEnd

          public void visitEnd()

      Deprecated.
      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`

    - #### getClassName

          public String getClassName()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return the name of the underlying class.
      Specified by:
        `getClassName` in interface `ClassMetadata`

    - #### isInterface

          public boolean isInterface()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return whether the underlying class represents an interface.
      Specified by:
        `isInterface` in interface `ClassMetadata`

    - #### isAnnotation

          public boolean isAnnotation()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return whether the underlying class represents an annotation.
      Specified by:
        `isAnnotation` in interface `ClassMetadata`

    - #### isAbstract

          public boolean isAbstract()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return whether the underlying class is marked as abstract.
      Specified by:
        `isAbstract` in interface `ClassMetadata`

    - #### isFinal

          public boolean isFinal()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return whether the underlying class is marked as 'final'.
      Specified by:
        `isFinal` in interface `ClassMetadata`

    - #### isIndependent

          public boolean isIndependent()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Determine whether the underlying class is independent, i.e. whether it is a top-level class or a nested class (static inner class) that can be constructed independently of an enclosing class.
      Specified by:
        `isIndependent` in interface `ClassMetadata`

    - #### hasEnclosingClass

          public boolean hasEnclosingClass()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return whether the underlying class is declared within an enclosing class (i.e. the underlying class is an inner/nested class or a local class within a method).

      If this method returns `false`, then the underlying class is a top-level class.

      Specified by:
        `hasEnclosingClass` in interface `ClassMetadata`

    - #### getEnclosingClassName

          @Nullable
          public String getEnclosingClassName()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return the name of the enclosing class of the underlying class, or `null` if the underlying class is a top-level class.
      Specified by:
        `getEnclosingClassName` in interface `ClassMetadata`

    - #### getSuperClassName

          @Nullable
          public String getSuperClassName()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return the name of the superclass of the underlying class, or `null` if there is no superclass defined.
      Specified by:
        `getSuperClassName` in interface `ClassMetadata`

    - #### getInterfaceNames

          public String[] getInterfaceNames()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return the names of all interfaces that the underlying class implements, or an empty array if there are none.
      Specified by:
        `getInterfaceNames` in interface `ClassMetadata`

    - #### getMemberClassNames

          public String[] getMemberClassNames()

      Deprecated.
      Description copied from interface: `ClassMetadata`
      Return the names of all classes declared as members of the class represented by this ClassMetadata object. This includes public, protected, default (package) access, and private classes and interfaces declared by the class, but excludes inherited classes and interfaces. An empty array is returned if no member classes or interfaces exist.
      Specified by:
        `getMemberClassNames` in interface `ClassMetadata`